package com.sun.ts.tests.securityapi.idstore.ldap.priorityuseforexpr;

import static javax.security.enterprise.identitystore.IdentityStore.ValidationType;
import static javax.security.enterprise.identitystore.IdentityStore.ValidationType.VALIDATE;
import javax.security.enterprise.identitystore.LdapIdentityStoreDefinition.LdapSearchScope;
import static javax.security.enterprise.identitystore.LdapIdentityStoreDefinition.LdapSearchScope.ONE_LEVEL;

import com.sun.ts.tests.securityapi.idstore.common.ConfigBean;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.List;
import javax.annotation.security.DeclareRoles;
import javax.security.enterprise.identitystore.LdapIdentityStoreDefinition;

import javax.servlet.ServletException;
import javax.servlet.annotation.HttpConstraint;
import javax.servlet.annotation.ServletSecurity;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;


import javax.annotation.sql.DataSourceDefinition;

@LdapIdentityStoreDefinition(
		url = "ldap://localhost:11389/",
		callerBaseDn = "ou=caller,dc=securityapi,dc=net",
		groupSearchBase  = "ou=group,dc=securityapi,dc=net",
		groupSearchFilter = "(&(member=%s)(objectClass=groupOfNames))",
		groupSearchScope = LdapSearchScope.ONE_LEVEL,
		useFor={ValidationType.VALIDATE},
		priority=100,
	    priorityExpression="#{configBean.priority300}",
	    useForExpression="${configBean.useforBoth}"
)

/**
 * Test Servlet that prints out the name of the authenticated caller and whether
 * this caller is in any of the roles {Administrator, Manager, Employee}
 *
 */
@DeclareRoles({"Administrator", "Manager", "Employee"})
@WebServlet("/ServletForLdapIDStore")
public class ServletForLdapIDStore extends HttpServlet {   
   

    @Override
    public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

    	 System.out.println("Inside ServletForLdapIDStore:doGet() ....." + "<BR>");
     	
     	
         String webName = null;
         if (request.getUserPrincipal() != null) {
         	System.out.println("The user principal is: " + request.getUserPrincipal().getName() + "<BR>");             
             webName = request.getUserPrincipal().getName();
         }

         response.getWriter().write("web username: " + webName + "\n");  
    }

}
